diff --git a/example/generator/odp_generator.c b/example/generator/odp_generator.c
index 1ed0c48..dfc5d2b 100644
--- a/example/generator/odp_generator.c
+++ b/example/generator/odp_generator.c
@@ -448,7 +448,7 @@ static void print_pkts(int thr, odp_packet_t pkt_tbl[], unsigned len)
 
 		odp_atomic_inc_u64(&counters.ip);
 		rlen += sprintf(msg, "receive Packet proto:IP ");
-		buf = odp_buffer_addr(odp_packet_to_buffer(pkt));
+		buf = odp_packet_data(pkt);
 		ip = (odph_ipv4hdr_t *)(buf + odp_packet_l3_offset(pkt));
 		rlen += sprintf(msg + rlen, "id %d ",
 				odp_be_to_cpu_16(ip->id));
diff --git a/example/ipsec/odp_ipsec.c b/example/ipsec/odp_ipsec.c
index 6e2c8b6..fd1b9b1 100644
--- a/example/ipsec/odp_ipsec.c
+++ b/example/ipsec/odp_ipsec.c
@@ -740,7 +740,7 @@ pkt_disposition_e do_ipsec_in_classify(odp_packet_t pkt,
 	*skip = FALSE;
 	if (odp_crypto_operation(&params,
 				 &posted,
-				 odp_packet_to_buffer(pkt))) {
+				 odp_buffer_from_event(odp_packet_to_event(pkt)))) {
 		abort();
 	}
 	return (posted) ? PKT_POSTED : PKT_CONTINUE;
@@ -766,7 +766,7 @@ pkt_disposition_e do_ipsec_in_finish(odp_packet_t pkt,
 	int trl_len = 0;
 
 	/* Check crypto result */
-	event = odp_packet_to_buffer(pkt);
+	event = odp_buffer_from_event(odp_packet_to_event(pkt));
 	odp_crypto_get_operation_compl_status(event, &auth_rc, &cipher_rc);
 	if (!is_crypto_compl_status_ok(&cipher_rc))
 		return PKT_DROP;
@@ -974,7 +974,7 @@ pkt_disposition_e do_ipsec_out_seq(odp_packet_t pkt,
 	/* Issue crypto request */
 	if (odp_crypto_operation(&ctx->ipsec.params,
 				 &posted,
-				 odp_packet_to_buffer(pkt))) {
+				 odp_buffer_from_event(odp_packet_to_event(pkt)))) {
 		abort();
 	}
 	return (posted) ? PKT_POSTED : PKT_CONTINUE;
@@ -998,7 +998,7 @@ pkt_disposition_e do_ipsec_out_finish(odp_packet_t pkt,
 	odph_ipv4hdr_t *ip;
 
 	/* Check crypto result */
-	event = odp_packet_to_buffer(pkt);
+	event = odp_buffer_from_event(odp_packet_to_event(pkt));
 	odp_crypto_get_operation_compl_status(event, &auth_rc, &cipher_rc);
 	if (!is_crypto_compl_status_ok(&cipher_rc))
 		return PKT_DROP;
diff --git a/platform/linux-generic/include/api/odp_packet.h b/platform/linux-generic/include/api/odp_packet.h
index 5ab96c6..c67fd62 100644
--- a/platform/linux-generic/include/api/odp_packet.h
+++ b/platform/linux-generic/include/api/odp_packet.h
@@ -105,15 +105,6 @@ int odp_packet_reset(odp_packet_t pkt, uint32_t len);
 odp_packet_t odp_packet_from_buffer(odp_buffer_t buf);
 
 /**
- * Convert a packet handle to a buffer handle
- *
- * @param pkt  Packet handle
- *
- * @return Buffer handle
- */
-odp_buffer_t odp_packet_to_buffer(odp_packet_t pkt);
-
-/**
  * Get packet handle from event
  *
  * Converts an ODP_EVENT_PACKET type event to a packet.
diff --git a/platform/linux-generic/include/odp_packet_internal.h b/platform/linux-generic/include/odp_packet_internal.h
index 179330c..fe4a223 100644
--- a/platform/linux-generic/include/odp_packet_internal.h
+++ b/platform/linux-generic/include/odp_packet_internal.h
@@ -257,6 +257,15 @@ odp_packet_t _odp_packet_alloc(odp_buffer_pool_t pool_hdl);
 
 int _odp_packet_parse(odp_packet_t pkt);
 
+/*
+ * Convert a packet handle to a buffer handle
+ *
+ * @param pkt  Packet handle
+ *
+ * @return Buffer handle
+ */
+odp_buffer_t _odp_packet_to_buffer(odp_packet_t pkt);
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/platform/linux-generic/odp_crypto.c b/platform/linux-generic/odp_crypto.c
index b468262..ab76484 100644
--- a/platform/linux-generic/odp_crypto.c
+++ b/platform/linux-generic/odp_crypto.c
@@ -364,9 +364,9 @@ odp_crypto_operation(odp_crypto_op_params_t *params,
 			ODP_ABORT();
 		_odp_packet_copy_to_packet(params->pkt, 0, params->out_pkt, 0,
 					   odp_packet_len(params->pkt));
-		if (completion_event == odp_packet_to_buffer(params->pkt))
+		if (completion_event == _odp_packet_to_buffer(params->pkt))
 			completion_event =
-				odp_packet_to_buffer(params->out_pkt);
+				_odp_packet_to_buffer(params->out_pkt);
 		odp_packet_free(params->pkt);
 		params->pkt = ODP_PACKET_INVALID;
 	}
diff --git a/platform/linux-generic/odp_packet.c b/platform/linux-generic/odp_packet.c
index ebe3b55..bcbac79 100644
--- a/platform/linux-generic/odp_packet.c
+++ b/platform/linux-generic/odp_packet.c
@@ -70,7 +70,7 @@ odp_packet_t odp_packet_from_buffer(odp_buffer_t buf)
 	return (odp_packet_t)buf;
 }
 
-odp_buffer_t odp_packet_to_buffer(odp_packet_t pkt)
+odp_buffer_t _odp_packet_to_buffer(odp_packet_t pkt)
 {
 	return (odp_buffer_t)pkt;
 }
diff --git a/platform/linux-generic/odp_packet_io.c b/platform/linux-generic/odp_packet_io.c
index cd109d2..7f5a95d 100644
--- a/platform/linux-generic/odp_packet_io.c
+++ b/platform/linux-generic/odp_packet_io.c
@@ -515,7 +515,7 @@ odp_buffer_hdr_t *pktin_dequeue(queue_entry_t *qentry)
 		return NULL;
 
 	for (i = 0, j = 0; i < pkts; ++i) {
-		buf = odp_packet_to_buffer(pkt_tbl[i]);
+		buf = _odp_packet_to_buffer(pkt_tbl[i]);
 		buf_hdr = odp_buf_to_hdr(buf);
 		if (0 > packet_classifier(qentry->s.pktin, pkt_tbl[i]))
 			tmp_hdr_tbl[j++] = buf_hdr;
@@ -561,7 +561,7 @@ int pktin_deq_multi(queue_entry_t *qentry, odp_buffer_hdr_t *buf_hdr[], int num)
 		return nbr;
 
 	for (i = 0, j = 0; i < pkts; ++i) {
-		buf = odp_packet_to_buffer(pkt_tbl[i]);
+		buf = _odp_packet_to_buffer(pkt_tbl[i]);
 		tmp_hdr = odp_buf_to_hdr(buf);
 		if (0 > packet_classifier(qentry->s.pktin, pkt_tbl[i]))
 			tmp_hdr_tbl[j++] = tmp_hdr;